=== debian/changelog ===
pg-auto-failover (2.1-2) unstable; urgency=medium

  * Relax dependency on pg-auto-failover-cli to >= so we can stop building
    packages for older PG versions without making them uninstallable.

 -- Christoph Berg <myon@debian.org>  Sat, 25 Nov 2023 09:52:08 +0000

pg-auto-failover (2.1-1) unstable; urgency=medium

  * New upstream version 2.1.
  * debian/rules: Generate src/bin/pg_autoctl/git-version.h.
  * debian/pgversions: Bump to 11+.

 -- Christoph Berg <myon@debian.org>  Fri, 24 Nov 2023 16:35:57 +0000

pg-auto-failover (2.0-3) unstable; urgency=medium

  * Upload for PostgreSQL 16.

 -- Christoph Berg <myon@debian.org>  Fri, 17 Nov 2023 09:56:02 +0000
