=== debian/control ===
Source: pg-auto-failover
Section: database
Priority: optional
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 flex,
 libedit-dev,
 libkrb5-dev,
 liblz4-dev,
 libncurses-dev,
 libpam0g-dev,
 libreadline-dev,
 libselinux1-dev,
 libssl-dev,
 libxslt1-dev,
 libzstd-dev,
 postgresql-server-dev-all (>= 158~),
 python3-sphinx,
 zlib1g-dev,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/citusdata/pg_auto_failover

Package: pg-auto-failover-cli
Architecture: any
Depends:
 openssl,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 postgresql-11-auto-failover | postgresql-12-auto-failover | postgresql-13-auto-failover | postgresql-14-auto-failover | postgresql-15-auto-failover | postgresql-16-auto-failover,
Description: Command line interface and service to manage pg auto failover Clusters
 This CLI is used to manage pg_auto_failover installations to provide High
 Availability to Postgres.

Package: postgresql-16-auto-failover
Architecture: any
Depends:
 pg-auto-failover-cli (>= ${binary:Version}),
 postgresql-16,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Postgres high availability support
 This extension implements a set of functions to provide High Availability to
 Postgres.
