=== debian/tests/control ===
Depends: @, postgresql-contrib-16
Tests: installcheck
Restrictions: allow-stderr
