## pg-auto-failover 2.2

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 .DEFAULT_GOAL := all
 
 # Supported PostgreSQL versions:
-PGVERSIONS = 11 12 13 14 15 16
+PGVERSIONS = 13 14 15 16 17
 
 # Default version:
 PGVERSION ?= $(lastword $(PGVERSIONS))
@@ -16,7 +16,7 @@
 # XXXX This should be in Makefile.citus only
 # but requires to clean up dockerfile and make targets related to citus first.
 # Default Citus Data version
-CITUSTAG ?= v12.1.0
+CITUSTAG ?= v13.0.1
 
 # TODO should be abs_top_dir ?
 TOP := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
@@ -191,7 +191,7 @@
 .PHONY: indent
 indent:
 	citus_indent
-	black .
+	black --exclude=ci/tools .
 
 # make lint; is an alias for make spellcheck
 # make linting; is an alias for make spellcheck
@@ -203,7 +203,7 @@
 .PHONY: spellcheck
 spellcheck:
 	citus_indent --check
-	black --check .
+	black --exclude=ci/tools --check .
 	ci/banned.h.sh
 
 #
@@ -272,12 +272,11 @@
 endif
 
 # We use pg not PG in uppercase in the var name to ease implicit rules matching
-BUILD_ARGS_pg11 = --build-arg PGVERSION=11 --build-arg CITUSTAG=v9.5.10
-BUILD_ARGS_pg12 = --build-arg PGVERSION=12 --build-arg CITUSTAG=v10.2.9
 BUILD_ARGS_pg13 = --build-arg PGVERSION=13 --build-arg CITUSTAG=v10.2.9
-BUILD_ARGS_pg14 = --build-arg PGVERSION=14 --build-arg CITUSTAG=$(CITUSTAG)
-BUILD_ARGS_pg15 = --build-arg PGVERSION=15 --build-arg CITUSTAG=$(CITUSTAG)
+BUILD_ARGS_pg14 = --build-arg PGVERSION=14 --build-arg CITUSTAG=v12.1.5
+BUILD_ARGS_pg15 = --build-arg PGVERSION=15 --build-arg CITUSTAG=v12.1.5
 BUILD_ARGS_pg16 = --build-arg PGVERSION=16 --build-arg CITUSTAG=$(CITUSTAG)
+BUILD_ARGS_pg17 = --build-arg PGVERSION=17 --build-arg CITUSTAG=$(CITUSTAG)
 
 # DOCKER BUILDS
 
@@ -288,10 +287,6 @@
 .PHONY: build-demo
 build-demo:
 	docker build $(BUILD_ARGS_pg$(PGVERSION)) -t citusdata/pg_auto_failover:demo .
-
-.PHONY: build-i386
-build-i386: Dockerfile.i386
-	docker build -t i386:latest -f Dockerfile.i386 .
 
 .PHONY: build-image
 build-image:
@@ -341,17 +336,6 @@
 		$(TEST_CONTAINER_NAME):pg$(PGVERSION)   \
 		make -C /usr/src/pg_auto_failover test	\
 		PGVERSION=$(PGVERSION) TEST='${TEST}'
-
-# expected to be run from within the i386 docker container
-.PHONY: installcheck-i386
-installcheck-i386:
-	pg_autoctl run &
-	pg_autoctl do pgsetup wait
-	$(MAKE) -C src/monitor installcheck
-
-.PHONY: run-installcheck-i386
-run-installcheck-i386: build-i386
-	docker run --platform linux/386 --rm -it --privileged i386 make installcheck-i386
 
 #
 # BE INTERACTIVE
@@ -451,3 +435,14 @@
 	BINPATH = ./src/bin/pg_autoctl/pg_autoctl
 	PG_AUTOCTL = PG_AUTOCTL_DEBUG=1 ./src/bin/pg_autoctl/pg_autoctl
 else
+	BINPATH = $(abspath $(TOP))/src/tools/pg_autoctl.valgrind
+	PG_AUTOCTL = PG_AUTOCTL_DEBUG=1 PG_AUTOCTL_DEBUG_BIN_PATH="$(BINPATH)" ./src/tools/pg_autoctl.valgrind
+endif
+
+VALGRIND_SESSION_TARGETS  = $(patsubst %,valgrind-session-pg%,$(PGVERSIONS))
+
+.SECONDEXPANSION:
+.PHONY: $(VALGRIND_SESSION_TARGETS)
+$(VALGRIND_SESSION_TARGETS): version $$(subst valgrind-session-,build-test-,$$@)
+	docker run
+	  --name $(TEST_CONTAINER_NAME)                \
