=== debian/changelog ===
pg-auto-failover (2.2-3) unstable; urgency=medium

  * Upload for PostgreSQL 18.
  * Build-Depends on libnuma-dev
  * Add patch to fix missing variable declarations error during build
  * Add patch to fix included copy of snprintf
  * Add patch to add variant comparison file for extension upgrade regress
    test
  * Add postgresql-common-dev to d/tests depends
  * Fix filenamemangle rule in d/watch

 -- Bradford D. Boyle <bradford.d.boyle@gmail.com>  Mon, 17 Nov 2025 12:24:16 +0100

pg-auto-failover (2.2-2) unstable; urgency=medium

  * Stop listing major versions explicitly in pg-auto-failover-cli's
    Recommends list. Use a generic postgresql-auto-failover virtual package
    instead. (Closes: #1095783)

 -- Christoph Berg <myon@debian.org>  Mon, 07 Apr 2025 12:33:40 +0200

pg-auto-failover (2.2-1) unstable; urgency=medium

  * New upstream version 2.2.
  * Packaging repository moved to salsa.

 -- Christoph Berg <myon@debian.org>  Thu, 03 Apr 2025 14:15:30 +0200

pg-auto-failover (2.1-3) unstable; urgency=medium

  * Upload for PostgreSQL 17.
  * Restrict to 64-bit architectures.
  * Use ${postgresql:Depends}.

 -- Christoph Berg <myon@debian.org>  Fri, 13 Sep 2024 14:31:10 +0200
