=== debian/control ===
Source: pg-auto-failover
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Dimitri Fontaine <dim@tapoueh.org>,
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit <!pkg.postgresql.32-bit>,
 flex,
 libedit-dev,
 libkrb5-dev,
 liblz4-dev,
 libncurses-dev,
 libnuma-dev,
 libpam0g-dev,
 libreadline-dev,
 libselinux1-dev,
 libssl-dev,
 libxslt1-dev,
 libzstd-dev,
 postgresql-server-dev-all (>= 158~),
 python3-sphinx,
 zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/citusdata/pg_auto_failover
Vcs-Browser: https://salsa.debian.org/postgresql/pg-auto-failover
Vcs-Git: https://salsa.debian.org/postgresql/pg-auto-failover.git

Package: pg-auto-failover-cli
Architecture: any
Depends:
 openssl,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 postgresql-auto-failover,
Description: Command line interface and service to manage pg auto failover Clusters
 This CLI is used to manage pg_auto_failover installations to provide High
 Availability to Postgres.

Package: postgresql-18-auto-failover
Architecture: any
Depends:
 pg-auto-failover-cli (>= ${binary:Version}),
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
Breaks:
 ${postgresql:Breaks},
Provides:
 postgresql-auto-failover,
Description: Postgres high availability support
 This extension implements a set of functions to provide High Availability to
 Postgres.
