=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
  https://github.com/citusdata/pg_auto_failover/tags .*/v?(\d\S*)\.tar\.gz
